﻿<?php
/*
Название программы: Cool Chmod v.1.6 FINAL. 2019 г.
Разработчик: Сергей Белов.
Назначение: более удобное использования команды PHP "chmod". Работает как с папками, так и с отдельным файлом. Если указана папка - меняются также права всех объектов внутри нее. Может работать в CRON.

Ссылка для проверки новой версии: http://www.bad-good.ru/programs.html#cool_chmod.
Основной сайт: http://www.bad-good.ru. Дополнительные: http://www.travel.bad-good.ru, http://www.moscow.bad-good.ru.
Тематика основного сайта: полезная информация. Тематика дополнительных сайтов: интересные места России, достопримечательности Москвы.

Лицензионное Соглашение на программу "Cool Chmod v.1.6 FINAL".
1) Настоящее Лицензионное соглашение (далее - "Соглашение") является предложением (публичной офертой), содержит порядок и существенные условия использования Вами (далее - "Пользователь") программы для ЭВМ "Cool Chmod v.1.6 FINAL" (далее - "Программа"). 
2) В соответствии с настоящим соглашением Автор (далее "Правообладатель") - обладатель исключительных имущественных авторских прав на Программу, обязуется предоставить Пользователю (напрямую либо через третьих лиц) неисключительное право на использование Программы, ограниченное правом инсталляции и запуска Программы в соответствии с установленными настоящим Соглашением (договором) правилами и условиями (простая неисключительная лицензия). 
3) Настоящее Соглашение (оферта/договор) считается акцептованной Пользователем в случае выбора пункта "Я согласен со всеми условиями соглашения", означает безоговорочное согласие Пользователя с условиями настоящего Соглашения.
4) Устанавливая или используя Программу, Пользователь полностью соглашается со всеми пунктами Соглашения. Если Пользователь не согласен с условиями этого Соглашения, Пользователь не имеет права устанавливать или использовать Программу. 
5) Пользователь не имеет права использовать Программу для нарушения какого-либо международного закона, закона РФ или закона страны, гражданином которой является Пользователь. 
6) Пользователь не имеет права использовать Программу для нарушения авторских и имущественных прав каких-либо лиц. 
7) Пользователь не имеет права дизассемблировать или переделывать любую часть Программы.
8) Пользователь не имеет права использовать Программу в коммерческих целях без согласия автора. "В коммерческих целях" означает для получения денежной или прочей материальной выгоды. Пользователь не имеет права арендовать, передавать в аренду или продавать Программу. 
9) Пользователь имеет право установить и использовать неограниченное количество копий этой редакции Программы на компьютерах, принадлежащих пользователю.
10) Пользователь имеет право выпускать эту редакцию Программы на носителях с другими программами (то есть, на сборниках программ), но только в оригинальном установочном архиве. 
11) Пользователь не имеет права выкладывать эту редакцию Программы на своем интернет-сайте, но имеет право размещать ссылку на сайт Правообладателя, в т.ч. ссылку на саму Программу.
12) Пользователь имеет право передавать эту редакцию программы другим лицам, но только в оригинальном установочном архиве. 
13) Правообладатель и/или его партнеры не несут ответственность за какие-либо убытки или ущерб, независимо от причин их возникновения (включая, но не ограничиваясь этим: особый, случайный или косвенный ущерб, убытки связанные с недополученной прибылью, прерыванием коммерческой или производственной деятельности, утратой личной, конфиденциальной или деловой информации, небрежностью, или какие-либо иные убытки), возникшие вследствие использования или невозможности использования Программы. 
14) Автор не может гарантировать техническую поддержку Программы.
15) За нарушение авторских прав на Программу нарушитель несет гражданскую, административную или уголовную ответственность в соответствии с законодательством Российской Федерации.

Также стоит отметить, что некоторым файлам можно поменять права только с помощью SSH, например .ftpaccess и .htaccess.
*/

//Переменные для main-функции. Глобальные переменные реализованы через жо - приходится передавать в функции как параметры. Или через global. Или с $_POST морочиться.

$CRON = false; //Запуск в CRON.

//Считывание данных.
$domain = $_POST['domain'];
$path = $_POST['path'];
$access = $_POST['access'];
$folder = $_POST['folder'];
$put_files = $_POST['put_files'];
$put_folders = $_POST['put_folders'];
$start = $_POST['start']; //После нажатия на "Запуск" = 1.

$array = split("/", $_SERVER["DOCUMENT_ROOT"]); //Переделка путей для функций.
$path_platform = "/".$array[0].$array[1]."/".$array[2]."/";
$path_chmod = $path_platform.$domain."/".$folder."/".$path;

if ($CRON == true)
{
	$domain = "/home/путь/bad-good.ru";
	$path = "attach/7";
	$access = "0777";
	$folder = "www";
	$start = "1";	
	$path_chmod = $domain."/".$folder."/".$path;
	$put_files = "ON";
	$put_folders = "ON";
}

if ($start == 1)
{		
	//$path_chmod = str_replace($path_chmod, "//", "/"); Глючит.
	
	if ($domain == "") view_error(2, NULL, "Не выбран домен!");
	if ($path == "") view_error(2, NULL, "Не заполнен путь!");
	if ($access == "") view_error(2, NULL, "Не заполнен доступ!");		
	else if (strlen($access) != 4) view_error(2, NULL, "Доступ заполнен неверно: ".$access.".");		
	if ($folder == "") view_error(2, NULL, "Не заполнена папка!");
	if (@fopen($path_chmod, "r") == false) view_error(2, NULL, "Путь/файл ".$path_chmod." не существует!");

	if ($path !="" && $domain!="" && $access!="" && strlen($access)==4 && $folder!="" && @fopen($path_chmod, "r")==true)
	{
		echo "Домен: ".$domain."<br>";
		echo "Путь: ".$path."<br>";
		echo "Доступ: ".$access."<br>";
		echo "Папка: ".$folder."<br><br>";
		echo "Обрабатывать файлы: ".$put_files."<br>";
		echo "Обрабатывать папки: ".$put_folders."<br><br>";

		echo "Выполнено по пути: ".$path_chmod."<br><br>"; //Вероятно, опасно выводить свои данные по виртуальной площадке в браузер, можете переделать.
		chmod_GO($path_chmod, $access, $put_files, $put_folders);
	}
}

function list_platform($path, $domain) //Автосканирование виртуальной площадки, если возможно. Найденные файлы отсекаются.
{
	if ($handle = opendir($path)) 
	{
		while (false !== ($file = readdir($handle)))
		{
			if (is_dir($path."/".$file)==true && $file!="." && $file!="..") create_radiobutton($file, $domain, "domain");
		}
		closedir($handle);
	}
	else view_error(1,$path,"Автосканирование виртуальной площадки");
}

function view_error($err_num, $file, $message) //Отображение результатов операций и прочих ошибок.
{
	if ($err_num == 0) echo "<font color=\"#32CD32\">"; //Успешная запись.
	if ($err_num == 1) echo "<font color=\"#00008B\">"; //Ошибка обработки определенного файла/папки.
	if ($err_num == 2) echo "<font color=\"#FF0000\">"; //Основные ошибки пользователя.
	
	echo $message;	
	if ($file != NULL) echo " ".$file;
	
	switch ($err_num)
	{
		case 0: echo " - успешно."; break;
		case 1: echo " - провалено."; break; //Если файл доступен для удаления/редактирования пользователем по FTP - тоже получим статус "провалено".
		//case 2: echo " - провалено."; break; //Данная ошибка не требует обработки.
	}
	
	echo "</font><br>";
}

function create_radiobutton($value, $check_value,$name) //Рисует radiobutton и отмечает ее, если была выбрана ранее.
{
	echo "<input type=\"Radio\" name=\"$name\" value=\"".$value."\" ";
	if (strcmp($value,$check_value)==0 && $check_value!="") echo "checked";
	echo " />".$value;
	if (strcmp($name,"domain") == 0) echo "<br>";
}

function chmod_GO($path, $perm, $put_files, $put_folders) 
{ 	
	$handle = opendir($path); 
	while (false !== ($file=readdir($handle)))
	{ 
		if ($file !== ".." && $file!==".") 
		{ 
			if (!is_file($path."/".$file))
			{
				if ($put_folders=="ON")
				{
					if (chmod($path."/". $file, octdec($perm)) == true) view_error(0,$path."/".$file,$perm); else view_error(1,$path."/".$file,$perm); //octdec обязательна.
				}
					
				chmod_GO($path. "/". $file, $perm, $put_files, $put_folders);
			}	
			else if ($put_files=="ON")
			{
				if (chmod($path."/".$file, octdec($perm)) == true) view_error(0,$path."/".$file,$perm); else view_error(1,$path."/".$file,$perm); //Функция octdec обязательна!
			}
		}
	}
	closedir($handle);
}
?>

<form action="#" method="post">
	Домен:<br>
	<?php
		echo "<i>Автоматически определенные домены:</i><br>";
		list_platform($path_platform, $domain); //Попытка просканировать виртуальную площадку на наличие доменов. Обычно прав на чтение у корневого каталога нет, нужно делать свой интерпретатор PHP.
		
		//Создаем выбор доменов руками.
		echo "<i>Вручную введенные домены:</i><br>";
		create_radiobutton("domain.ru)", $domain, "domain");
		create_radiobutton("bad-good.ru", $domain, "domain");
	?>
	
	<br>Путь к папке/файлу: <input type="text" size="100" name="path" value="<?php echo $path;?>" />
	<br><input type="checkbox" name="put_files" value="ON" checked> Обрабатывать файлы
	<br><input type="checkbox" name="put_folders" value="ON"> Обрабатывать папки
	<br>
	<input type="hidden" name="start" value="1" />
	<br>Доступ: <input type="text" name="access" maxlength="4" value="<?php if ($access!="") echo $access; else echo "0777"; ?>" /><br>
	<br>Папка: 
	
	<?php
		//Стандартный набор папок для виртуальной площадки.
		create_radiobutton("cgi-bin", $folder, "folder");
		create_radiobutton("tmp", $folder, "folder");
		create_radiobutton("www", $folder, "folder");
	?>
	<br><br>
	<input type="submit" value="Запуск">
</form>